#lang scheme

(require "../2b/cub-type.ss"
         "../misc/env.ss"
         "../1b/cub-packrat-parse.ss")

(provide/contract
 [well-formed-test-case-file (-> (or/c path? string?) syntax?)])

(define (well-formed-test-case-file file.tig)
  (let ([p (call-with-input-file file.tig packrat-parse-port)]
        [m (let-values ([(base name dir) (split-path file.tig)])
             (regexp-match #rx"^(...)" (path->string name)))])
    (cond
      [(not m) 
       (error 'filename "expected the filename to begin with either int, str, or ant")]
      [(let ([fn-prefix (cadr m)])
         (not (or (regexp-match #rx"^ant" fn-prefix)
                  (regexp-match #rx"^int" fn-prefix)
                  (regexp-match #rx"^str" fn-prefix))))
       (error 'filename "expected the filename to begin with either int, str, or ant")]
      [(not p)
       (error 'parse-error)]
      [else
       (let ([type (cub-tc p)]
             [fn-prefix (cadr m)])
         (define (check ty-pred? pfx)
           (when (equal? pfx fn-prefix)
             (unless (ty-pred? type)
               (error 'filename 
                      "the program has type ~a, but the filename does not begin with \"~a\""
                      (render-type type)
                      pfx))))
         (check (let ([int-ty? (lambda (x) (eq? x int-ty))]) int-ty?) "int")
         (check (let ([str-ty? (lambda (x) (eq? x string-ty))]) str-ty?) "str")
         (check array-of-int? "ant")
         
         p)])))