#lang scheme

(require "tree-exp-red.ss"
         redex/reduction-semantics)

(test-->> tree-exp-red
          (term (() pc (move (mem 4) 1)))
          (term (((4 1)) (move (mem 4) 1) pc)))

(test-->> tree-exp-red
          (term (() pc (move (mem 4) 1) (move (mem 4) 2)))
          (term (((4 2)) (move (mem 4) 1) (move (mem 4) 2) pc)))

(test-->> tree-exp-red
          (term (() pc (move (mem 4) 1) (move (mem 4) (+ (mem 4) 2))))
          (term (((4 3)) (move (mem 4) 1) (move (mem 4) (+ (mem 4) 2)) pc)))

(test-->> tree-exp-red
          (term (() pc (move r:1 1) (move (mem 4) r:1)))
          (term (((r:1 1) (4 1)) (move r:1 1) (move (mem 4) r:1) pc)))

(test-->> tree-exp-red
          (term (() pc (seq (move r:1 1) (move (mem 4) r:1))))
          (term (((r:1 1) (4 1)) (move r:1 1) (move (mem 4) r:1) pc)))

(test-->> tree-exp-red
          (term (() pc (move (mem 12) (eseq (move r:1 1) r:1))))
          (term (((r:1 1) (12 1)) (move r:1 1) (move (mem 12) r:1) pc)))

(test-->> tree-exp-red
          (term (() pc (move (mem 12) (eseq (move r:1 1) (eseq (move (mem 4) r:1) (mem 4))))))
          (term (((r:1 1) (4 1) (12 1)) (move r:1 1) (move (mem 4) r:1) (move (mem 12) (mem 4)) pc)))

(test-->> tree-exp-red
          (term (() pc (move r:1 (call "allocate" 1))))
          (term (((r:1 4) (4 0)) (move r:1 (call "allocate" 1)) pc)))

(test-->> tree-exp-red
          (term (() pc (move r:1 (call "allocate" 4))))
          (term (((r:1 4) (4 0) (8 0) (12 0) (16 0)) (move r:1 (call "allocate" 4)) pc)))

(test-->> tree-exp-red
          (term (() pc (move r:1 (+ 4 (call "allocate" 4)))))
          (term (((r:temp 4) (4 0) (8 0) (12 0) (16 0) (r:1 8)) (move r:temp (call "allocate" 4)) (move r:1 (+ 4 r:temp)) pc)))

(test-->> tree-exp-red (term (() pc l:x l:y)) (term (() l:x l:y pc)))

(test-->> tree-exp-red
          (term (() pc 
                    (move (mem 4) 8)
                    (jump l:after l:after)
                    (move (mem 4) 12)
                    l:after))
          (term (((4 8)) 
                 (move (mem 4) 8)
                 (jump l:after l:after)
                 (move (mem 4) 12)
                 l:after
                 pc)))

(test-->> tree-exp-red
          (term 
           (()
            pc 
            (move (mem 4) 8)
            (cjump < 0 1 l:x l:y)
            l:x
            (move (mem 4) 12)
            (jump l:done l:done)
            l:y
            (move (mem 4) 16)
            l:done))
          (term
           (((4 12))
            (move (mem 4) 8)
            (cjump < 0 1 l:x l:y)
            l:x
            (move (mem 4) 12)
            (jump l:done l:done)
            l:y
            (move (mem 4) 16)
            l:done
            pc)))

(test-->> tree-exp-red
          (term 
           (()
            pc 
            (move (mem 4) 8)
            (cjump < 1 0 l:x l:y)
            l:x
            (move (mem 4) 12)
            (jump l:done l:done)
            l:y
            (move (mem 4) 16)
            l:done))
          (term
           (((4 16))
            (move (mem 4) 8)
            (cjump < 1 0 l:x l:y)
            l:x
            (move (mem 4) 12)
            (jump l:done l:done)
            l:y
            (move (mem 4) 16)
            l:done
            pc)))
(test-results)
